#!/usr/bin/php-cgi
<?php
	error_reporting(0);
	
	header('Content-type: text/html; charset=utf-8');
	
	$isserv = true;
	include("globals.php");
	
	function updateavailablelist($fname, $add) {
		if ($add) {
			$ret = false;
			$f = $GLOBALS['passPath'] . "mflist";
			$fh;
			if (is_file($f)) {
				$fh = fopen($f, 'a');
				
				while (($line = fgets($fh)) !== false) {
					if (trim($line) == trim($fname)) {
						$ret = true;
						break;
					}
				}
			} else {
				$fh = fopen($f, 'w+');
			}
			
			fwrite($fh, "\n". $fname);
			
			fclose($fh);
		} else {
			$data = file($GLOBALS['passPath'] . "mflist");
			$out = array();
			foreach($data as $line) {
				if (trim($line) != $fname) {
					//if (trim($line) > 0) {
						$out[] = $line;
					//}
				}
			}
			
			$fp = fopen($GLOBALS['passPath'] . "mflist", "w+");
			flock($fp, LOCK_EX);
			foreach($out as $line) {
				fwrite($fp, $line);
			}
			flock($fp, LOCK_UN);
			fclose($fp);  
		}
	}
	
	function checkfileavailable($fname) {
		$f = $GLOBALS['passPath'] . "mflist";
		if (is_file($f)) {
			$fh = fopen($f, 'r');
			
			while (($line = fgets($fh)) !== false) {
				if (trim($line) == trim($fname)) {
					$ret = true;
					break;
				}
			}
			
			fclose($fh);
		} else {
			$fh = fopen($f, 'w+');
			fclose($fh);
		}
		
		return $ret;
	}
	
	//$act: 1-get files;
	$act = 1;
	if (isset($_POST['act'])) {
		$act = stripslashes($_POST['act']);
	} else if (isset($_GET['act'])) {
		$act = stripslashes($_GET['act']);
	}
	if (strlen($act) == 0) {$act = 1;}
	$act = trim($act);
	
	$path = "";
	if (isset($_POST['path'])) {
		$path = stripslashes($_POST['path']);
	} else if (isset($_GET['path'])) {
		$path = stripslashes($_GET['path']);
	}
	$currpath = trim($path);
	
	$fname = "";
	if (isset($_POST['fname'])) {
		$fname = stripslashes($_POST['fname']);
	} else if (isset($_GET['fname'])) {
		$fname = stripslashes($_GET['fname']);
	}
	$fname = trim($fname);
	
	if (($act == 0) || ($act == "0")) { //Delete file
		if (file_exists($GLOBALS['fileloc'] . $path . '/' . $fname)) {
			unlink($GLOBALS['fileloc'] . $path . '/' . $fname);
			updateavailablelist($fname, false);
		}
	} else if (($act == 6) || ($act == "6")) { //Add to avail
		updateavailablelist($fname, true);
	} else if (($act == 7) || ($act == "7")) { //Remove from avail
		updateavailablelist($fname, false);
	}
	
	//FETCH FILES AND FOLDER
	if (is_dir($GLOBALS['fileloc'] . $path)) {
		
		$dirfiles = scandir($GLOBALS['fileloc'] . $path);
		for ($i=0;$i<count($dirfiles);$i++) {
			if (is_dir($GLOBALS['fileloc'] . $path . DIRECTORY_SEPARATOR . $dirfiles[$i])) {
				$dirfiles[$i] = "[DIR]" . $dirfiles[$i];
			}
		}
	
	} else {
		$dirfiles = array();
	}
	
	if (!isset($dirfiles)) {$dirfiles = array();}
	
	$cnt = 0;
	echo '<table width="800" id="mediaview" border="0" cellspacing="0" cellpadding="8" align="center">';

	if (strlen($currpath) > 0) {
	?>
		<tr><td><a href="javascript:;" onclick="gouponefolderJS('<?php echo $currpath; ?>')"><img height="20" src="<?php echo $GLOBALS['plugFilePath']; ?>/img/folderup.jpg"> Up One Folder</a></td></tr>
		<tr><td>Current Path: .<?php echo $currpath; ?></td></tr>
	<?php
	}

	for ($i=0; $i<count($dirfiles); $i++) {
		if (substr($dirfiles[$i], 0, 5) === "[DIR]") {
			/*if (($dirfiles[$i] == "[DIR].") || ($dirfiles[$i] == "[DIR]..")) {} else {
				$cnt++;
			?>
                <tr><td><a href="javascript:;" title="Click to open folder" onclick="gotofolderJS('<?php echo $currpath . '/' . str_ireplace("[DIR]", "", $dirfiles[$i]); ?>')"><img height="20" src="<?php echo $GLOBALS['plugFilePath']; ?>/img/folder.jpg"><?php echo "&nbsp;" . str_ireplace("[DIR]", "", $dirfiles[$i]); ?></a></td></tr>  
                <?php
			}*/
		} else {
			//CHECK IF FILE IS ACTIVATED
			$isavail = checkfileavailable(str_ireplace("[DIR]", "", $dirfiles[$i]));
			$class = ""; $act = 1;
			if (!$isavail) {$class = ' class="na"'; $act = 0;}
			?>
            <tr><td><a href="javascript:;" title="Click for options" <?php echo $class; ?> onclick="showopts('<?php echo str_ireplace("[DIR]", "", $dirfiles[$i]); ?>', '<?php echo $act; ?>');"><img height="20" src="<?php echo $GLOBALS['plugFilePath']; ?>/img/file.jpg"><?php echo "&nbsp;" . str_ireplace("[DIR]", "", $dirfiles[$i]); ?></a></td></tr>
            <?php
			$cnt++;
		}
	}
	
	if ($cnt == 0) {
		?>
        <tr><td>No files found.</td></tr>
        <?php
	}
	
	echo '</table>';
?>