#!/usr/bin/php-cgi
<?php
session_start();
/*update
post_max_size
memory_limit
max_execution_time
max_input_time
*/

if(isset($_GET['CHECKSUM'])){
  echo '<p style="padding:0;color:black;display:inline;font-size:13px;font-family:tahoma">&nbsp;&nbsp;'.md5_file('/tmp/firmware.img').'</p>';
  exit;
}

if(isset($_GET['install_firmware_upload'])){
  unset($_SESSION['UPLOAD_TEMP_IDEN']);
  unset($_SESSION['UPLOAD_TEMP_IDEN']);
  exec('/etc/smsg/upgradefirmware');
  
  echo 'Firmware Installation';
  exit;
}

if ($_SERVER["REQUEST_METHOD"] == "POST" && !empty($_FILES["userfile"])) {
  define("UPLOAD_DIR", "/tmp/");
  if (!empty($_FILES["userfile"])) {
      $myFile = $_FILES["userfile"];

      if ($myFile["error"] !== UPLOAD_ERR_OK) {
          echo '<p style="padding:0;color:red;font-size:13px;font-family:tahoma">An error has occurred. code '.$myFile["error"].'</p>';
          exit;
      }


      $file_check = pathinfo($myFile['name']);
      if(strtolower($file_check['extension']) !== 'img'){
        echo '<p style="padding:0;color:red;font-size:13px;font-family:tahoma">Invalid file.</p>';
        exit;
      }else{
        
      }
      
      
      // ensure a safe filename
      $name = preg_replace("/[^A-Z0-9._-]/i", "_", 'firmware.img');      
      $success = move_uploaded_file($myFile["tmp_name"],UPLOAD_DIR . $name);
      if (!$success) { 
          echo '<p style="padding:0;color:red;font-size:13px;font-family:tahoma">Error! File was not uploaded, Error Number '.$myfile["error"].'</p>';
          exit;
      }else{
          $_SESSION['UPLOAD_TEMP_IDEN'] = time();
          echo '<p style="padding:0;color:black;font-size:13px;font-family:tahoma">File was successfully uploaded</p>';
          exit;
      }

      // set proper permissions on the new file
      chmod(UPLOAD_DIR . $name, 0777);
  }
}
?>

<html>
 <head>
  <title>CrewCommWifi | Upgrade</title>
  <style>

    html{
      background: #305CB7;
/* Permalink - use to edit and share this gradient: http://colorzilla.com/gradient-editor/#499bea+0,207ce5+100;Blue+3d+%237 */
background: #499bea; /* Old browsers */
background: -moz-linear-gradient(top,  #499bea 0%, #207ce5 100%); /* FF3.6-15 */
background: -webkit-linear-gradient(top,  #499bea 0%,#207ce5 100%); /* Chrome10-25,Safari5.1-6 */
background: linear-gradient(to bottom,  #499bea 0%,#207ce5 100%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#499bea', endColorstr='#207ce5',GradientType=0 ); /* IE6-9 */

    }

  html
  {
    font-family:Verdana, Geneva, sans-serif;
    font-size:14px;
    color: black;
    
    background: url(/crewmailfiles/img/bg1.png) no-repeat; 
    -webkit-background-size: cover;
    -moz-background-size: cover;
    -o-background-size: cover;
    background-size: cover;
  }
    *,html,body{
      margin:0;
      padding:0;
    }

    *,html,body{
     font-family: "tahoma";
    }
    #bar_blank {
      border: solid 1px #fff;
      height: 20px;
      width: 99.8%;
    }

    #bar_color {
    background-color: #052567;
    color: #fff;
      height: 20px;
      width: 0px;
    }

    #bar_blank, #hidden_iframe {
      /*display: none;*/
    }

    #hidden_iframe{
      border: none;
      width: 360px;
      height: 22px;
      overflow: hidden;
      display: inline;
    }

    div#installation-container{
      border:3px solid #DDD;
      width:44%;
      margin: 4% auto;
      background: #C8BEBE;
    }

    div.header{
      height: 30px;
      background: #052567;
      padding:0 10px;
    }
    div.footer{
      background: #DDD;
    }
    div.header p{
      line-height: 2;
      color:#fff;
    }

    #installation-container div.body,
    #installation-container div.footer
    {
          padding: 0px 10px 5px 3px;
    }

    #installation-container div.body{
      min-height: 33%;
      height: 33%;
      /* width: 100%; */
      padding: 20px 20px 0 7%;
    }

    .clearfix:after {
       content: " "; /* Older browser do not support empty content */
       visibility: hidden;
       display: block;
       height: 0;
       clear: both;
    }

    #firmware_install_modal {
      width: 300px;
      height: 65px;
      border: 1px solid Black;
      text-align: center;
      padding: 15px 5px;
      background: #DDD;
      color: #000;
      position: absolute;
      top: calc(50vh - (/* height */100px / 2));
      left: calc(50vw - (/* width */300px / 2));
      font-family: tahoma;
      font-size: 13px;
      line-height: 20px;
    }
    .modal{
      display:none;
    }
    .modal.active{
      display: block;
      width: 100%;
      height: 100%;
      overflow: hidden;
      background: rgba(221,221,221,0.8);
      position:absolute;
      top: 0;
      left:0;
    }
    input[type=submit],button{
      padding:4px 6px;
      font-size:12px;
    }
    input[type=file]{
      /*border: 1px solid #CCC;*/
      padding: 2px 0px;
      font-size: 13px;
    }

    ul.instructions{

    }

  .hide{
    display:none;
  }

  .show{
    display: inline;
  }

    ul.instructions li{
      font-size: 12px;
      margin: 10px 0 0 0;
      list-style: none;
    }
  </style>
 </head>
 <body> 
  <div id="installation-container">
    <div class="header">
      <p>CrewCommCenter Firmware Upgrade</p>
    </div>
    <div class="body">
      <div class="content">
        <br>
        <p style="margin-left: 24%;">Welcome to the Firmware Upgrade Wizard</p>
        <br>
        <p>
        <ul class="instructions">
          <li><span>Step 1:</span> Click <b>Choose File</b> to browse and select the firmware IMG file.</li>
          <li><span>Step 2:</span> After selecting file click on <b>Start Upload</b>, this will upload the firmware on CrewCommWifi</li>
          <li><span>Step 3:</span> A checksum verification code will appear if the file was successfully uploaded</li>
          <li><span>Step 4:</span> Click on <b>Install Firmware</b> to proceed with the firmware installation and wait for the router to reboot</li>
        </ul>
        </p>
      </div>

    </div>
    <div class="clearfix"></div>

    <?php if(isset($_GET['process']) && $_GET['process'] == 'install'):?>
      <div class="footer">
      <?php if(file_exists('/tmp/firmware.img') && isset($_SESSION['UPLOAD_TEMP_IDEN'])):?>
        <code>Check Sum <?php echo md5_file('/tmp/firmware.img');?></code><br>

        <form action="<?php echo $_SERVER["PHP_SELF"];?>?process=install" method="POST" id="install_firmware_proceed" style="display:inline">
         <input type="hidden" name="install_firmware_upload" value="true">
         <input type="submit" value="CONFIRM FIRMWARE INSTALLATION">
        </form>
        <a href="/cgi-bin/upload.php"><button>Cancel</button></a>

      <?php else:?>
        <p>FIRMWARE.IMG does not exists</p>
      <?php endif;?>
      <div id="myForm"></div>
      </div>
    <?php else:?>
      <div class="loading" style="background: #DDD;padding: 5px 0 0 0;">
      <div id="bar_blank" style="display:block;">
        <div id="bar_color"><span id="status"></span></div>
      </div>
      </div>  
    <div class="footer">  
      <br>
        <form action="<?php echo $_SERVER["PHP_SELF"]; ?>" method="POST" id="myForm" enctype="multipart/form-data" target="hidden_iframe" style="display:inline">
         <input type="hidden" value="myForm" name="<?php echo ini_get("session.upload_progress.name"); ?>">
         <input type="file" id="uploadFIle" name="userfile" style="width:100%" placeholder="">
         <input type="submit" id="uploadBtn" value="Start Upload" class="hide">
        </form>
        <iframe id="hidden_iframe" name="hidden_iframe" src="about:blank" scrolling="no"></iframe>
        <br><span id="InstallFMbtn" stlye="margin-top:5px"></span><span id="CheckSUmNumber" stlye="margin-top:5px"></span>
        <div class="clearfix"></div>
        </div>
    <?php endif;?>
    
  </div>

  <div id="modal" class="modal">
      <div id="firmware_install_modal">
        <p>Firmware is installing<br>Please do not close the browser</p>
        <p>The router will automatically reboot</p>
      </div>
  </div>

  <script type="text/javascript">
    function toggleBarVisibility() {
        // var e = document.getElementById("bar_blank");
        // e.style.display = (e.style.display == "block") ? "none" : "block";
    }

    function createRequestObject() {
        var http;
        if (navigator.appName == "Microsoft Internet Explorer") {
            http = new ActiveXObject("Microsoft.XMLHTTP");
        }
        else {
            http = new XMLHttpRequest();
        }
        return http;
    }

    function sendRequest() {
        var http = createRequestObject();
        http.open("GET", "progress.php");
        http.onreadystatechange = function () { handleResponse(http); };
        http.send(null);
    }

    function getCheckSUm(){
      var http = createRequestObject();
      http.open("GET", "upgrade.php?CHECKSUM");
      http.onreadystatechange = function () { showChecksum(http); };
      http.send(null);
    }

    function showChecksum(http){
      var response;
      if (http.readyState == 4) {
        response = http.responseText;
        document.getElementById("CheckSUmNumber").innerHTML = response;
      }
    }        
    
    function startUpload() {
        toggleBarVisibility();
        setTimeout("sendRequest()", 1000);
    }

    function installFirmware(){
      var txt;
      var r = confirm("Install current uploaded firmware?");
      if (r == true) {
           document.getElementById("modal").className = "modal active";

            var http = createRequestObject();
            http.open("GET", "upgrade.php?install_firmware_upload");
            http.send();
      } else {
          alert('Firmware Installation was cancelled');
      }
    }

    document.getElementById('uploadFIle').onchange = function(){
      document.getElementById('uploadBtn').className = 'show';
    };

    function handleResponse(http) {
        var response;
        if (http.readyState == 4) {
            response = http.responseText;
            console.log(response);
            if(response == '00error'){
              return ;
            }else{
              if (response < 100) {
                document.getElementById("bar_color").style.width = response + "%";
                document.getElementById("status").innerHTML = response + "%";
                setTimeout("sendRequest()", 1000);
              } else {
                  toggleBarVisibility();
                  document.getElementById("status").innerHTML = '';
                  // document.getElementById("InstallFMbtn").innerHTML = '<form onsubmit="installFirmware" action="<?php echo $_SERVER["PHP_SELF"];?>" method="POST" id="install_firmware_proceed" style="display:inline"><input type="hidden" name="install_firmware_upload" value="true"><input style="margin: 7px 0 0 0;" type="submit" value="Install Firmware"></form><button><a href="upgrade.php" style="text-decoration:none;color:black">Cancel</a></button>';
                  document.getElementById("InstallFMbtn").innerHTML = '<button style="margin-top:10px" onclick="installFirmware();return false;">Install Firmware</button><button><a href="upgrade.php" style="text-decoration:none;color:black">Cancel</a></button>';
                  getCheckSUm();
              }
            }            
        }
    }

    (function () {
        document.getElementById("myForm").onsubmit = startUpload;
    })();
  </script>
 </body>
</html>