$(document).ready(function(){

    /*CHeck height and apply to class with 'js-auto-height'*/
	(function($,window,document){

        /*on load*/
        var windowHeight = $(window).height();
        $('.js-auto-height').css('min-height', windowHeight+'px');
        /*resized*/
        $(window).on('resize',function(){
            var windowHeight = $(window).height();
            
            $('.js-auto-height').css('min-height', windowHeight+'px');
        });
        //console.log(windowHeight);
    })(jQuery,window,document,undefined)


    $('#dynamicYear').text( (new Date).getFullYear()  );
});

/*
    Anonymous functions
*/
(function($,window,document){

    function initHeaderNav(){
        $("#sidemenu-open").click(function(e) {
            e.preventDefault();
            $(this).parent('li').toggleClass('selected');
            $("#wrapper").toggleClass("toggled");
        });


        $("#search-open").click(function(e) {
            e.preventDefault();
            $(this).parent('li').toggleClass('selected');
            $(".search-container").toggleClass("show-searchbar");
            $('.search-container input').focus();
        });
    }


    function initSidemenuLinks(){

        $('.haschild-menu').on('click',function(e){
            e.preventDefault();
            var elem = $(this);

            elem.parent('li').toggleClass('menu-open');
            // elem.next('ul').slideToggle();
        });
    }


    //call all functions when document is ready
    $(document).ready(function(){
        initHeaderNav();
        initSidemenuLinks();
    });


})(jQuery,window,document,undefined);


/*tooltip*/
$(function () {
  if($('[data-toggle="tooltip"]') !== "undefined"){
      $('[data-toggle="tooltip"]').tooltip();
  }
});

/*Chat Accordion Script*/
(function($,window,document){
    function initAccordion()
    {
        if($('.chat-accordion-panel__body') !== "undefined")
        {
            $('.chat-accordion-panel__body').on('show.bs.collapse', function () {
                    var elem = $(this);
                    elem.siblings('.chat-accordion-panel__body')
                             .find('.chat-accordion-panel__body-content.in')
                             .removeClass('in');
                });
        }
    }
        initAccordion();
})(jQuery,window,document,undefined);

/* =============/================ */
(function($){
    $('#selectall').on('change', function(event) {
        // event.preventDefault();
        if($(this).is(':checked')){
            $('.checkbox-for-message').prop({
                checked: 'checked'
            });
        }else{
            $('.checkbox-for-message').prop({
                checked: ''
            });
        }
    });
    
    $('.email_input_form_contacts').focus(function(event) {
        event.preventDefault();
        $('.email_input_form_contacts-add-user').css('visibility','hidden');
        $(this).siblings('.email_input_form_contacts-add-user').css('visibility','visible');
    });
})(jQuery,window,document);
/* =============/================ */